---
# tasks file for gitlab-runner

- name: "Configuration of repository"
  become: yes
  become_user: root
  template:
    src: ./templates/repo.j2
    dest: /etc/yum.repos.d/gitlab-runner.repo
    owner: root
    group: root
    setype: 'system_conf_t'
    mode: '0644'

- name: 'Install gitlab runner'
  become: yes
  become_user: root
  yum:
    name: gitlab-runner
    state: present
    update_cache: yes
    disable_gpg_check: no

- name: 'Tune concurrent param into configs'
  become: yes
  become_user: root
  lineinfile:
    path: /etc/gitlab-runner/config.toml
    regexp: '^concurrent = '
    line: "concurrent = {{ cdd_runner_concurrent }}"
  notify: 'Restart gitlab-runner'

- name: 'Tune concurrent param into configs - custom folder'
  tags: test
  become: yes
  become_user: root
  lineinfile:
    path: /etc/gitlab-runner/config.toml
    regexp: '\[runners.custom_build_dir\]'
    line: "  [runners.custom_build_dir] \n\   enabled = true \n"
    backrefs: yes

- name: 'Tune concurrent param into configs - custom folder - fix for idempotency'
  tags: test
  become: yes
  become_user: root
  replace:
    path: /etc/gitlab-runner/config.toml
    regexp: '^   enabled = true \n\   enabled = true \n'
    replace: "   enabled = true \n"

- name: 'Restart gitlab-runner'
  become: yes
  service:
    name: 'gitlab-runner'
    state: 'restarted'

- name: 'List configured runners'
  command: gitlab-runner list
  register: configured_runners
  changed_when: False
  become: yes
  check_mode: no

- name: 'Register runner to GitLab'
  become: yes
  become_user: root
  command: >
    gitlab-runner register
    --non-interactive
    --url "{{ cdd_gitlab_url }}"
    --registration-token "{{ lookup('env', 'RUNNER_REGISTRATION_TOKEN') }}"
    --executor "{{ cdd_runner_executor }}"
    --description "{{ cdd_runner_description }}"
    --tag-list {{ cdd_runner_tag }}
    --run-untagged
    --locked="{{ cdd_runner_lock }}"
  when: configured_runners.stderr.find('\n' + cdd_runner_description) == -1
#  no_log: yes
